#include    "stm32F10x.h"

void init_clock (void){
  
//**********************    PLL *************************
//******************************************************************************
	RCC->CR|=RCC_CR_HSEON; //   HSE
	while (!(RCC->CR & RCC_CR_HSERDY)){} //   HSE
	//RCC->CR|=RCC_CR_CSSON; //     HSE
	
	RCC->CFGR |= RCC_CFGR_HPRE_DIV1; // HCLK = SYSCLK  
	RCC->CFGR |= RCC_CFGR_PPRE2_DIV1; // PCLK2 = HCLK
	RCC->CFGR |= RCC_CFGR_PPRE1_DIV1; // PCLK1 = HCLK

	RCC->CFGR2 &= ~RCC_CFGR2_PREDIV1; // 
	RCC->CFGR &= ~(RCC_CFGR_PLLSRC | RCC_CFGR_PLLXTPRE | RCC_CFGR_PLLMULL); // 
	RCC->CFGR2 |= RCC_CFGR2_PREDIV1_DIV4; //   HSE  4
	RCC->CFGR |= RCC_CFGR_PLLSRC_PREDIV1; //  PLL  HSE/PREDIV1
	RCC->CFGR |= RCC_CFGR_PLLMULL12; //    12
	RCC->CR |= RCC_CR_PLLON; //  PLL
	while((RCC->CR & RCC_CR_PLLRDY)==0){} //   PLL
	RCC->CFGR &=~RCC_CFGR_SW; //   SW0, SW1
	RCC->CFGR |= RCC_CFGR_SW_PLL; //    PLL
	while ((RCC->CFGR&RCC_CFGR_SWS)!=0x08); //    PLL
//******************************************************************************
//******************************************************************************
}

void init_peripherals (void){

//*********************     ****************************
//******************************************************************************     
	RCC->APB2ENR |= RCC_APB2ENR_IOPAEN; //    A
	RCC->APB2ENR |= RCC_APB2ENR_IOPBEN; //    B
	RCC->APB2ENR |= RCC_APB2ENR_IOPCEN; //    C
	GPIOC->CRH   |= GPIO_CRH_MODE8; //   LED4 PC8  
	GPIOC->CRH   &=~GPIO_CRH_CNF8; //     PC8
	GPIOC->CRH   |= GPIO_CRH_MODE9; //   LED3 PC9  
	GPIOC->CRH   &=~GPIO_CRH_CNF9; //    PC9
	GPIOA->CRL   &=~GPIO_CRL_MODE0; //  "USER" PA0 -  
	
	GPIOB->CRH   |= GPIO_CRH_MODE12|GPIO_CRH_MODE13|GPIO_CRH_MODE14|GPIO_CRH_MODE15;
	GPIOB->CRH   &= ~(GPIO_CRH_CNF12|GPIO_CRH_CNF13|GPIO_CRH_CNF14|GPIO_CRH_CNF15);
	
	GPIOB->CRH   |= GPIO_CRH_MODE8|GPIO_CRH_MODE9|GPIO_CRH_MODE10|GPIO_CRH_MODE11;
	GPIOB->CRH   &= ~(GPIO_CRH_CNF8|GPIO_CRH_CNF9|GPIO_CRH_CNF10|GPIO_CRH_CNF11);
	
	//GPIOC->CRL &= ~GPIO_CRL_MODE6;
	GPIOA->CRL &= ~GPIO_CRL_CNF1;
	/*
	//    PC8, PC9.
	GPIOC->LCKR   = GPIO_LCKR_LCK8|GPIO_LCKR_LCK9|GPIO_LCKR_LCKK;
	GPIOC->LCKR   = GPIO_LCKR_LCK8|GPIO_LCKR_LCK9;
	GPIOC->LCKR   = GPIO_LCKR_LCK8|GPIO_LCKR_LCK9|GPIO_LCKR_LCKK;
	tmp=GPIOC->LCKR; tmp=GPIOC->LCKR;
     */
//******************************************************************************
//******************************************************************************

//*********************    ***************************
//******************************************************************************    
	RCC->APB2ENR |= RCC_APB2ENR_AFIOEN; //   .

	AFIO->EXTICR[0] &= ~AFIO_EXTICR1_EXTI0_PA; // .
	AFIO->EXTICR[0] |= AFIO_EXTICR1_EXTI0_PA; //      

	EXTI->EMR &= ~EXTI_EMR_MR0; //     

	//EXTI->FTSR |= EXTI_FTSR_TR0; //       
	EXTI->RTSR |= EXTI_RTSR_TR0; //       

	EXTI->IMR &= ~EXTI_IMR_MR0; // .
	EXTI->IMR |= EXTI_IMR_MR0; //    EXTIO
	//NVIC_SetPriority(EXTI0_IRQn, 15); //     EXTIO
	//NVIC_EnableIRQ (EXTI0_IRQn); //    EXTIO  NVIC.
//******************************************************************************

//**********************************  ***************************************
//******************************************************************************
	RCC->APB2ENR |= RCC_APB2ENR_ADC1EN;	//    
	ADC1->CR2 |= ADC_CR2_ADON; //    
	ADC1->CR2 |= ADC_CR2_TSVREFE; //    .    .
	ADC1->CR2 |= ADC_CR2_EXTSEL; //      swstart      
	ADC1->CR2 |= ADC_CR2_EXTTRIG; //      (   )
	ADC1->SMPR2 |= ADC_SMPR2_SMP1; // . -  (239.5)    1 
	ADC1->SQR3 |= ADC_SQR3_SQ1_0; //  1  (0b00001)  1  (-    1) 
//******************************************************************************
//******************************************************************************

//*************************   SysTick ***************************
//******************************************************************************
	SysTick->LOAD = 24000;
	SysTick->CTRL |= SysTick_CTRL_CLKSOURCE; //Clock = HCLK
	//SysTick->CTRL &= ~SysTick_CTRL_CLKSOURCE; //Clock = HCLK/8
	SysTick->VAL = 0; //
	SysTick->CTRL |= SysTick_CTRL_ENABLE; //   SysTick
	NVIC_SetPriority(SysTick_IRQn, 15); //    SysTick
	SysTick->CTRL |= SysTick_CTRL_TICKINT; //   SysTick
//******************************************************************************
//******************************************************************************
	
//********************************  16 ***********************************
//******************************************************************************
	RCC->APB2ENR |= RCC_APB2ENR_TIM16EN; //    17
	TIM16->PSC = 160 - 1; //   
	//TIM17->ARR = (620*4) - 1;
	TIM16->ARR = 92 - 1;
	TIM16->DIER |= TIM_DIER_UIE;
	TIM16->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;
	
	NVIC_SetPriority(TIM1_UP_TIM16_IRQn, 14);
	NVIC_EnableIRQ(TIM1_UP_TIM16_IRQn);
//******************************************************************************
//******************************************************************************
	
//********************************  17 ***********************************
//******************************************************************************
	RCC->APB2ENR |= RCC_APB2ENR_TIM17EN; //    17
	TIM17->PSC = 160 - 1; //   
	//TIM17->ARR = (620*4) - 1;
	TIM17->ARR = 92 - 1;
	TIM17->DIER |= TIM_DIER_UIE;
	TIM17->CR1 = TIM_CR1_CEN | TIM_CR1_ARPE;
	
	NVIC_SetPriority(TIM1_TRG_COM_TIM17_IRQn, 13);
	NVIC_EnableIRQ(TIM1_TRG_COM_TIM17_IRQn);
//******************************************************************************
//******************************************************************************

//********************************** USART1 ************************************
//******************************************************************************
	RCC->APB2ENR |= RCC_APB2ENR_IOPAEN; //    A
    RCC->APB2ENR |= RCC_APB2ENR_AFIOEN; //    GPIO
    RCC->APB2ENR |= RCC_APB2ENR_USART1EN; //   USART1
    GPIOA->CRH |= GPIO_CRH_MODE9; //  TX PA.9 -  
    GPIOA->CRH &= ~GPIO_CRH_CNF9; GPIOA->CRH |=GPIO_CRH_CNF9_1; //  
    USART1->CR1 |=(USART_CR1_RE | USART_CR1_TE); //   RX, TX
	//  9.6 kbps. USARTDIV=FSYS/(16*baud) = 24e6/(16*9600)=156.25
	USART1->BRR = (156<<4); //   156
	USART1->BRR |= 4; //  *16 = 0,25*16 = 4
	
	USART1->CR1 |= USART_CR1_RXNEIE; //   RXNE
	USART1->CR1 |= USART_CR1_TCIE; //   TC
	
	USART1->CR1 |= USART_CR1_UE; //  USART1
	NVIC_SetPriority(USART1_IRQn, 15); //    USART1
	NVIC_EnableIRQ(USART1_IRQn); //   USART1_IRQn  NVIC
//******************************************************************************
//******************************************************************************
}
